# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without maven
%bcond_without repolib

%define reltag .redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}
%global base_name beanutils
%global short_name commons-beanutils

%define section free

Name:           apache-commons-beanutils
Version:        1.8.3
Release:        5%{?reltag}%{?dist}
Epoch:          0
Summary:        Apache Commons BeanUtils
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://commons.apache.org/%{base_name}/
Source0:        http://www.apache.org/dist/commons/beanutils/source/commons-beanutils-1.8.3-src.tar.gz
Source1:        commons-beanutils-bean-collections-1.8.3.pom
Source2:        commons-beanutils-core-1.8.3.pom
Patch0:         commons-beanutils-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Provides:       %{short_name} = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name} < %{epoch}:%{version}-%{release}
Provides:       jakarta-%{short_name} = %{epoch}:%{version}-%{release}
Requires:       java >= 0:1.6.0
Requires:       slf4j
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jboss-parent >= 0:8
BuildRequires:  jpackage-utils
BuildRequires:  ant >= 0:1.7
BuildRequires:  ant-junit
BuildRequires:  junit
%if %with maven
BuildRequires:  commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
%endif
BuildRequires:  commons-collections
BuildRequires:  commons-collections-testframework
BuildRequires:  slf4j
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{short_name}-%{version}-%{release}-root

%description
The scope of this package is to create a package of Java utility methods
for accessing and modifying the properties of arbitrary JavaBeans.  No
dependencies outside of the JDK are required, so the use of this package
is very lightweight.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java
Provides:       %{short_name}-repolib = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-repolib < %{epoch}:%{version}-%{release}
Provides:       jakarta-%{short_name}-repolib = %{epoch}:%{version}-%{release}

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{short_name}
Group:          Development/Documentation
Requires:       jpackage-utils
Provides:       %{short_name}-javadoc = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-javadoc < %{epoch}:%{version}-%{release}
Provides:       jakarta-%{short_name}-javadoc = %{epoch}:%{version}-%{release}

%description javadoc
%{summary}.

%if %with maven
%package manual
Summary:        Documents for %{short_name}
Group:          Development/Documentation
Provides:       %{short_name}-manual = %{epoch}:%{version}-%{release}
Obsoletes:      jakarta-%{short_name}-manual < %{epoch}:%{version}-%{release}
Provides:       jakarta-%{short_name}-manual = %{epoch}:%{version}-%{release}

%description manual
%{summary}.
%endif

%prep
%setup -q -n %{short_name}-%{version}-src
%{__cp} -p %{SOURCE1} .
%{__cp} -p %{SOURCE2} .
%patch0 -p1 -b .sav0

%{__rm} -r src/main/java/org/apache/commons/collections/

%{__rm} src/test/java/org/apache/commons/beanutils/BeanMapTestCase.java

%build
%if %with maven
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file://`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.failure.ignore=true deploy javadoc:javadoc
%else
export CLASSPATH=$(build-classpath commons-collections jcl-over-slf4j)
export OPT_JAR_LIST="ant/ant-junit junit"
%{ant} -Dbuild.sysclasspath=first test dist
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %with maven
%{__cp} -p target/%{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
%{__cp} -p target/%{short_name}-bean-collections-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-bean-collections-%{namedversion}.jar
%{__cp} -p target/%{short_name}-core-%{namedversion}.jar %{buildroot}%{_javadir}/%{short_name}-core-%{namedversion}.jar
%else
%{__cp} -p dist/%{short_name}-%{version}.jar %{buildroot}%{_javadir}/%{short_name}-%{namedversion}.jar
%{__cp} -p dist/%{short_name}-core-%{version}.jar %{buildroot}%{_javadir}/%{short_name}-core-%{namedversion}.jar
%{__cp} -p dist/%{short_name}-bean-collections-%{version}.jar %{buildroot}%{_javadir}/%{short_name}-bean-collections-%{namedversion}.jar
%endif
%{__ln_s} %{short_name}-%{namedversion}.jar %{buildroot}%{_javadir}/jakarta-%{short_name}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | sed "s|-%{namedversion}||g"`; done)

%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{short_name}.pom
%{__cp} -p %{short_name}-bean-collections-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-bean-collections.pom
%{__cp} -p %{short_name}-core-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-%{short_name}-core.pom

%add_to_maven_depmap %{short_name} %{short_name} %{namedversion} JPP %{short_name}
%add_to_maven_depmap %{short_name} %{short_name}-core %{namedversion} JPP %{short_name}-core
%add_to_maven_depmap %{short_name} %{short_name}-bean-collections %{namedversion} JPP %{short_name}-bean-collections
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/%{short_name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%if %with maven
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%else
%{__cp} -pr dist/docs/api/* %{buildroot}%{_javadocdir}/%{short_name}-%{namedversion}
%endif
%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/%{short_name}
%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
%{__ln_s} jakarta-%{short_name}-%{namedversion} %{buildroot}%{_javadocdir}/jakarta-%{short_name}

# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{short_name}-%{namedversion}
%if %with maven
%{__cp} -pr target/site %{buildroot}%{_docdir}/%{short_name}-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/%{short_name}-%{namedversion}/site/apidocs
%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_docdir}/%{short_name}-%{namedversion}/site/apidocs
%endif
%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_docdir}/%{short_name}
%{__ln_s} %{short_name}-%{namedversion} %{buildroot}%{_docdir}/jakarta-%{short_name}-%{namedversion}
%{__ln_s} jakarta-%{short_name}-%{namedversion} %{buildroot}%{_docdir}/jakarta-%{short_name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com

# Add sources and patches
mkdir tmp
pushd tmp
tar xf %{SOURCE0}
mv %{short_name}-%{version}-src %{short_name}-%{version}
zip -q -9 -r %{short_name}-%{short_name}-%{namedversion}-sources.zip %{short_name}-%{version}
mkdir %{short_name}
cp %{PATCH0} %{short_name}
zip -q -9 -r %{short_name}-%{short_name}-%{namedversion}-patches.zip %{short_name}
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp -DperformRelease=true deploy:deploy-file -Dfile=%{short_name}-%{short_name}-%{namedversion}-sources.zip -DrepositoryId=jboss-releases-repository -Durl=${URL} -DartifactId=%{short_name}-repolib -Dclassifier=sources -DgroupId=%{short_name} -Dpackaging=zip -Dversion=%{namedversion}
%{_bindir}/mvn-jpp -DperformRelease=true deploy:deploy-file -Dfile=%{short_name}-%{short_name}-%{namedversion}-patches.zip -DrepositoryId=jboss-releases-repository -Durl=${URL} -DartifactId=%{short_name}-repolib -Dclassifier=patches -DgroupId=%{short_name} -Dpackaging=zip -Dversion=%{namedversion}
popd
rm -Rf tmp
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt NOTICE.txt README.txt RELEASE-NOTES.txt
%{_javadir}*/%{short_name}-%{namedversion}.jar
%{_javadir}*/%{short_name}.jar
%{_javadir}*/jakarta-%{short_name}-%{namedversion}.jar
%{_javadir}*/jakarta-%{short_name}.jar
%{_javadir}*/%{short_name}-core-%{namedversion}.jar
%{_javadir}*/%{short_name}-core.jar
%{_javadir}*/%{short_name}-bean-collections-%{namedversion}.jar
%{_javadir}*/%{short_name}-bean-collections.jar
%{_mavenpomdir}/JPP-%{short_name}.pom
%{_mavenpomdir}/JPP-%{short_name}-core.pom
%{_mavenpomdir}/JPP-%{short_name}-bean-collections.pom
%{_mavendepmapfragdir}/%{short_name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{short_name}-%{namedversion}
%{_javadocdir}/%{short_name}
%{_javadocdir}/jakarta-%{short_name}-%{namedversion}
%{_javadocdir}/jakarta-%{short_name}

%if %with maven
%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{short_name}-%{namedversion}
%{_docdir}/%{short_name}
%{_docdir}/jakarta-%{short_name}-%{namedversion}
%{_docdir}/jakarta-%{short_name}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Apr 27 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.8.3-5.redhat_1
- Add sources and patches to maven2-brew directory in repolib

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.8.3-4.7_redhat_1.1
- Rebuild using cache signing

* Mon Feb 20 2012 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.7
- remove included commons-collections sources and add to pom

* Wed Feb 08 2012 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.6
- replace commons-logging by jcl-over-slf4j
- update poms
- disable use of commons-collections-testframework (missing pom upstream)

* Thu Feb 02 2012 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.5_redhat_1
- update jboss-parent version

* Fri Nov 11 2011 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.4_redhat_1
- fix Release tag

* Wed Nov 09 2011 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.3
- remove bad Obsoletes

* Tue Nov 08 2011 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.2
- rebuild for deploy bug

* Mon Nov 07 2011 David Walluck <dwalluck@redhat.com> 0:1.8.3-4.1
- use actual file names
- fix javadoc dir symlinks
- fix backwards compat symlinks
- fix file list
- fix docs install
- remove Requires: commons-collections (optional)
- remove gcj support
- remove triggerpostun
- remove old-style repolib
- add maven repolib

* Thu Dec 09 2010 Ralph Apel <r.apel@r-apel.de> 0:1.8.3-4
- Fix compat symlinks for obsoleted jakarta-commons-beanutils

* Thu Oct 07 2010 Ralph Apel <r.apel@r-apel.de> 0:1.8.3-3
- Provide compat symlinks for obsoleted jakarta-commons-beanutils

* Thu Sep 23 2010 Ralph Apel <r.apel@r-apel.de> 0:1.8.3-2
- Drop Requires: for apache-commons-parent

* Sat Sep 04 2010 Ralph Apel <r.apel@r-apel.de> 0:1.8.3-1
- 1.8.3

* Wed Nov 18 2009 Ralph Apel <r.apel@r-apel.de> 0:1.8.1-1
- 1.8.1
- rename to apache-commons-beanutils
- build with maven2 by default

* Thu Jan 22 2009 David Walluck <dwalluck@redhat.com> 0:1.8.0-4
- spec cleannup

* Wed Jan 07 2009 David Walluck <dwalluck@redhat.com> 0:1.8.0-3
- add simple poms and sync upstream dependencies

* Wed Jan 07 2009 David Walluck <dwalluck@redhat.com> 0:1.8.0-2
- remove bundled commons-collections classes
- bump commons-collections requirement to 3.0 or later

* Tue Jan 06 2009 David Walluck <dwalluck@redhat.com> 0:1.8.0-1
- 1.8.0

* Mon Oct 20 2008 David Walluck <dwalluck@redhat.com> 0:1.7.0-10
- add flag to build with maven

* Fri Sep 19 2008 David Walluck <dwalluck@redhat.com> 0:1.7.0-9
- add jdk6 patch
- fix repolib

* Sun Jun 15 2008 David Walluck <dwalluck@redhat.com> 0:1.7.0-8.jpp5
- fix duplicate files
- correctly unpack sources
- remove spurious gnu-crypto requirement
- remove spurious javadoc package requirements
- fix javadoc directory
- fix build-classpath call
- use macros

* Fri May 30 2008 Permaine Cheung <pcheung@redhat.com> - 0:1.7.0-7
- First JPP5 build

* Tue Jul 24 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.7.0-6jpp
- Make Vendor, Distribution based on macro
- Fix aot build
- Add poms and depmap frags
- Build with maven1 by default
- Add manual subpackage when built with maven

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.7.0-2jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-2jpp.ep1.1
- New repolib location

* Mon Mar 05 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-2jpp.el4ep1.3
- Remove pre section used for RHUG cleanup

* Tue Feb 20 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.7.0-2jpp.el4ep1.2
- Add -brew suffix

* Fri Feb 17 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:1.7.0-2jpp.el4ep1.1
- Add repolib support

* Thu Aug 17 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-5jpp
- Require what is used in post/postun for javadoc

* Fri Jul 14 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-4jpp
- Add AOT bits

* Thu May 11 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-3jpp
- Add header
- Remove unecessary macro definitions

* Wed Feb 22 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-2jpp_1rh
- Merge with upstream

* Wed Apr 27 2005 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-1jpp_3rh
- Fix build so that collections jar is created

* Sat Jan 29 2005 Ralph Apel <r.apel@r-apel.de> - 0:1.7.0-2jpp
- Use the "dist" target to get a full build, including bean-collections

* Thu Oct 21 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-1jpp_1rh
- Import from upstream

* Thu Oct 21 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.7.0-1jpp
- Upgrade to 1.7.0

* Fri Oct 1 2004 Andrew Overholt <overholt@redhat.com> 0:1.6.1-4jpp_6rh
- add coreutils BuildRequires

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.6.1-5jpp
- Rebuild with ant-1.6.2

* Fri Jul 2 2004 Aizaz Ahmed <aahmed@redhat.com> 0:1.6.1-4jpp_5rh
- Added trigger to restore symlinks that are removed if ugrading
  from a commons-beanutils rhug package

* Fri Apr  2 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.6.1-4jpp_4rh
- more of the same, for version-suffixed .jar files

* Fri Mar 26 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.6.1-4jpp_3rh
- add RHUG upgrade cleanup

* Fri Mar  5 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.6.1-4jpp_2rh
- RH vacuuming part II

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> 0:1.6.1-4jpp_1rh
- RH vacuuming

* Fri May 09 2003 David Walluck <david@anti-microsoft.org> 0:1.6.1-4jpp
- update for JPackage 1.5

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.6.1-2jpp
- fix ASF license and add packager name

* Wed Feb 19 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.6.1-1jpp
- 1.6.1

* Thu Feb 13 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.6-1jpp
- 1.6

* Thu Oct 24 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.5-1jpp
- 1.5

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.4.1-1jpp
- 1.4.1

* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.4-1jpp
- 1.4

* Fri Jul 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.3-3jpp
- change to commons-xxx.jar instead of commons-xxx.home in ant parameters

* Mon Jun 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.3-2jpp
- use sed instead of bash 2.x extension in link area to make spec compatible
  with distro using bash 1.1x

* Fri Jun 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.3-1jpp 
- 1.3
- added short names in %%{_javadir}, as does jakarta developpers
- first jPackage release
